<template>
  <div  id="display" class="col-auto q-pa-md" >

    <h5 class="relative-position" v-ripple v-on:click="toggleEditable()">
      {{valueName.toUpperCase()}}:
    </h5>

      <span v-html="displayValue" v-if="(!editable || valueName==='id') && !selfEditable" class="text-body1" id="val"></span>
      <div class="q-my-md q-pa-md" v-else>
        <q-input v-if="inputType !== 'description' && !minMaxValue"
          dark
          v-model="newValue"
          :type="inputType"
          label="Bearbeiten" />
        <q-editor
          v-else-if="!minMaxValue"
          flat
          dense
          square
          toolbar-text-color="secondary"
          toolbar-toggle-color="info"
          toolbar-bg="primary"
          v-model="newValue"
          min-height="10rem"
          />
        <div v-else>

          <q-input
          dark
          v-model.number="current"
          :type="inputType"
          :rules="[current => current <= max || 'Current sollte nicht größer als MAX sein.']"
          label="current"/>

          <q-input
          dark
          v-model.number="max"
          :type="inputType"
          label="max"/>

        </div>
        <q-btn
          class="full-width q-mt-md"
          color="info"
          icon="check"
          label="OK"
          @click="commitChange()" />
      </div>

    <slot></slot>

  </div>
</template>

<script>
import { type } from 'os';

export default {
  props: {
    valueName: String,
    value: [String, Number, Object],
    editable: [Boolean],
    subCategory: [String]
  },
  // name: 'ComponentName',
  data () {
    return {
      newValue: undefined,
      numeric: false,
      selfEditable: false,
      inputType: null,
      minMaxValue: false,
      current: 0,
      max: 0
    }
  },
  methods: {
    commitChange: function () {
      if (this.minMaxValue) {
        this.newValue = {
          current: this.current,
          max: this.max
        }
      }
      this.$emit('changedValue', this.valueName, this.newValue, this.subCategory);
      this.selfEditable = false;
    },
    toggleEditable: function () {
      this.selfEditable = !this.selfEditable;
    }
  },
  computed: {
    displayValue: function() {
      if (this.minMaxValue) {
        return (this.newValue.current + " / " + this.newValue.max)
      }
      return this.newValue;
    }
  },
  created() {
    this.newValue = this.value;
    if (this.valueName !== "description") {
      if (typeof this.newValue === 'object') {
        if ('max' in this.newValue && 'current' in this.newValue) {
          this.inputType = 'number';
          this.minMaxValue = true;
          this.current = this.newValue.current;
          this.max = this.newValue.max;
        }
      } else {
        this.inputType = typeof this.newValue;
      }
    } else {
      this.inputType = 'description';
    }
  }
}
</script>
<style lang="sass" scoped>
  #display
    background-color: $primary;
    vertical-align: middle;
  h5
    font-size: 20px;
  .text-body1
    color: $info;
    font-size: 1em;
    // vertical-align: middle;
    // text-align: center;
  h5
    margin: 0px 5px;
</style>
